#####

<p align="center">
    <img src="images/icon.png" width="176" />
    <h2 align="center">Bienvenue sur <code>au3WebDriver</code></h2>
</p>

[![licence](https://img.shields.io/badge/license-MIT-ff69b4.svg?style=flat-square&logo=spdx)][licence]
[![contributeurs](https://img.shields.io/github/contributors/Danp2/au3WebDriver.svg?style=flat-square&logo=github)][Contributeurs]
![taille du dépôt](https://img.shields.io/github/repo-size/Danp2/au3WebDriver.svg?style=flat-square&logo=github)
[![dernier commit](https://img.shields.io/github/last-commit/Danp2/au3WebDriver.svg?style=flat-square&logo=github)](https://github.com/Danp2/au3WebDriver /commit/master)
[![release](https://img.shields.io/github/release/Danp2/au3WebDriver.svg?style=flat-square&logo=github)](https://github.com/Danp2/au3WebDriver/releases/ dernier)
![os](https://img.shields.io/badge/os-windows-yellow.svg?style=flat-square&logo=windows)
![étoiles](https://img.shields.io/github/stars/Danp2/au3WebDriver?color=blueviolet&logo=reverbnation&logoColor=white&style=flat-square)

[Description](#description) | [Documentation](#documentation) | [Fonctionnalités](#fonctionnalités) | [Mise en route](#getting-started) | [Configuration](#configuration) | [Contribuer](#contribuer) | [Licence](#licence) | [Remerciements](#remerciements)

## La description

Cette UDF (projet) au3WebDriver permet d'interagir avec n'importe quel navigateur prenant en charge les [spécifications W3C WebDriver][W3C Webdriver]. La prise en charge de plusieurs navigateurs via la même base de code est désormais possible avec seulement quelques paramètres de configuration.

## Documentation

| | Référence | Descriptif |
| :---: | :--- | :--- |
| <img src="https://upload.wikimedia.org/wikipedia/commons/thumb/5/5e/W3C_icon.svg/212px-W3C_icon.svg.png" width="20"> | [Pilote Web W3C] | Norme/spécification officielle W3C WebDriver. |
| 📚 | [Wiki WebDriver] | Plus d'informations sur cette UDF (projet) comme la vue d'ensemble, les capacités, le dépannage et plus encore. |
| 📖 | Webdriver.chm | Fichier d'aide de la fonction CHM fourni avec ce téléchargement UDF (projet). |

## Caractéristiques

### *Prise en charge du navigateur*

| Chrome | Bord | Firefox | Opéra |
|------------|---------|----------------|-------- ----|
| ![Chrome48] | ![Bord48] | ![Firefox48] | ![Opéra48] |

### *Les fonctions*

<détails>
<summary><i>Fonctions principales</i></summary>
<p>

| Nom | Descriptif |
| :--- | :--- |
| _WD_CréerSession | Demander une nouvelle session au pilote Web. |
| _WD_SupprimerSession | Supprimer la session existante. |
| _WD_Statut | Obtenez l'état actuel du pilote Web. |
| _WD_GetSession | Obtenez des détails sur la session existante. |
| _WD_Timeouts | Définissez ou récupérez les paramètres de délai d'expiration de la session. |
| _WD_Naviguer | Accédez à l'URL désignée. |
| _WD_Action | Effectuez diverses interactions avec la session du pilote Web. |
| _WD_Fenêtre | Effectuer des interactions liées à la fenêtre en cours. |
| _WD_FindElement | Trouvez des éléments par stratégie désignée. |
| _WD_ElementAction | Effectuer une action sur l'élément désigné. |
| _WD_ExécuterScript | Exécutez les commandes Javascipt. |
| _WD_Alerte | Répondre à l'invite de l'utilisateur. |
| _WD_GetSource | Obtenir la source de la page. |
| _WD_Cookies | Obtient, définit ou supprime les cookies de la session. |
| _WD_Option | Définit et obtient les options pour l'UDF du pilote Web. |
| _WD_Démarrage | Lancez l'application de console de pilote Web désignée. |
| _WD_Arrêt | Tuez l'application de la console du pilote Web. |

<p>
</détails>

<détails>
<summary><i>Fonctions d'assistance</i></summary>
<p>

| Nom | Descriptif |
| :--- | :--- |
| _WD_NouvelTab | Créer un nouvel onglet dans la session de navigateur en cours. |
| _WD_Attach | Joindre à l'onglet de navigateur existant. |
| _WD_LienClicParTexte | Simulez un clic de souris sur un lien dont le texte correspond à la chaîne fournie. |
| _WD_WaitElement | Attendre un élément dans l'onglet courant avant de revenir. |
| _WD_GetMouseElement | Récupère la référence à l'élément sous le pointeur de la souris. |
| _WD_GetElementFromPoint | Récupère la référence à l'élément au point spécifié. |
| _WD_DernierRésultatHTTP | Renvoie le résultat de la dernière requête WinHTTP. |
| _WD_LastHTTPResponse | Renvoie la réponse de la dernière requête WinHTTP. |
| _WD_GetFrameCount | Renvoie le nombre d'images/iframes dans le contexte de document actuel. |
| _WD_IsWindowTop | Renvoie un booléen de la session étant au niveau supérieur, ou dans un ou plusieurs cadres. |
| _WD_FrameEntrée | Entrez le cadre spécifié. |
| _WD_FrameLeave | Laisse le cadre actuel à son parent. |
| _WD_HighlightElement | Met en surbrillance l'élément spécifié. |
| _WD_HighlightElements | Met en surbrillance les éléments spécifiés. |
| _WD_LoadWait | Attendez qu'une page de navigateur se charge avant de revenir. |
| _WD_Capture d'écran | Prend une capture d'écran de la fenêtre ou de l'élément. |
| _WD_ImprimerVersPDF | Imprimer l'onglet courant au format PDF paginé. |
| _WD_jQuerify | Injecter la bibliothèque jQuery dans la session en cours. |
| _WD_ElementOptionSelect | Recherchez et cliquez sur une option d'un élément Sélectionner. |
| _WD_ElementSelectAction | Effectuer une action sur l'élément Select désigné. |
| _WD_ConsoleVisible | Contrôlez la visibilité de l'application de la console Webdriver. |
| _WD_GetShadowRoot | Récupère la racine fantôme d'un élément. |
| _WD_SelectFichiers | Sélectionnez les fichiers à télécharger sur un site Web. |
| _WD_IsLatestRelease | Compare la version UDF locale à la dernière version sur Github. |
| _WD_UpdateDriver | Remplacez le pilote Web par une version plus récente, si disponible. |
| _WD_GetBrowserVersion | Obtenir le numéro de version du navigateur spécifié. |
| _WD_GetBrowserPath | Récupérer le chemin d'accès à l'exécutable du navigateur à partir du registre. |
| _WD_GetWebDriverVersion | Obtenez le numéro de version du pilote Web spécifié. |
| _WD_TéléchargerFichier | Téléchargez le fichier et enregistrez-le sur le disque. |
| _WD_SetTimeouts | Fonction conviviale pour définir les délais d'expiration de la session du pilote Web. |
| _WD_GetElementById | Localisez l'élément par identifiant. |
| _WD_GetElementByName | Localisez l'élément par son nom. |
| _WD_SetElementValue | Définir la valeur de l'élément désigné. |
| _WD_ElementActionEx | Effectuer une action avancée sur l'élément désigné. |
| _WD_GetTable | Renvoie tous les éléments d'un tableau. |
| _WD_EstPleinÉcran | Renvoie un booléen indiquant si la session est en mode plein écran. |
| _WD_GetDevicePixelRatio | Renvoie un entier indiquant le DevicePixelRatio. |
| _WD_CheckContext | Vérifiez si le contexte du navigateur est toujours valide. |
| _WD_JsonActionKey | Formate les chaînes "action" du clavier à utiliser dans _WD_Action |
| _WD_JsonActionPointer | Formate les chaînes "action" de pointeur à utiliser dans _WD_Action |
| _WD_JsonActionPause | Formate les chaînes "action" de pause à utiliser dans _WD_Action |
| _WD_JsonCookie | Formate les chaînes JSON "cookie" à utiliser dans _WD_Cookies. |

<p>
</détails>

<détails>
<summary><i>Fonctions CDP</i></summary>
<p>

| Nom | Descriptif |
| :--- | :--- |
| _WD_CDPExécuteCommande | Exécutez la commande CDP. |
| _WD_CDPGetSettings | Récupérez les paramètres liés au CDP à partir du navigateur. |

<p>
</détails>

<détails>
<summary><i>Fonctions de capacités</i></summary>
<p>

| Nom | Descriptif |
| :--- | :--- |
| _WD_CapabilitiesStartup | Démarrer une nouvelle génération de capacités |
| _WD_CapabilitiesAdd | Ajouter des fonctionnalités à la chaîne JSON |
| _WD_CapabilitiesObtenir | Obtenez la chaîne JSON |
| _WD_CapabilitiesDump | Vider vers la console |
| _WD_CapabilitiesDefine | Définissez une nouvelle capacité en sélectionnant un type et en spécifiant un nom |

<p>
</détails>

## Commencer

#### *Conditions préalables*

Téléchargez et ajoutez les fichiers UDF tiers obligatoires suivants à votre dossier de projet (indépendamment du navigateur que vous souhaitez automatiser).

- Obligatoire ✔
  - [Json UDF] - L'archive inclut *Json.au3* & *BinaryCall.au3*.
  - [WinHTTP UDF] - L'archive inclut *WinHttp.au3* & *WinHttpConstants.au3*.
- Facultatif ⚠
  - [HtmlTable2Array UDF] - Extraction de données de tableaux HTML vers un tableau.
  - [WinHttp_WebSocket UDF] - Nécessaire pour la fonctionnalité Websocket CDP.

Téléchargez et installez l'un des WebDrivers suivants (en fonction du type et de la version du navigateur que vous souhaitez automatiser).

| Navigateur | Télécharger | État de mise en œuvre |
|:------------ :|----------------------|----------- -------------------|
| ![Chrome16] | [Chrome][ChromeDL] | [Statut][ChromeStatut] |
| ![Bord16] | [Bord][BordDL] | [Statut][EdgeStatus] |
| ![Firefox16] | [Firefox][FirefoxDL] | [Statut][FirefoxStatus] [^1] |
| ![Opéra16] | [Opéra][OperaDL] | [^2] |

Avis de limitation. [^3]

[^1] : Connexion requise
[^2] : dérivé de ChromeDriver par projet [ReadMe][Opera ReadMe]
[^3] : Toutes les fonctions de WebDriver n'ont pas été entièrement implémentées par chaque navigateur. Gardez cela à l'esprit et vérifiez le "Statut de mise en œuvre" pour le WebDriver de votre choix.

#### *Installation*

Pour automatiser votre navigateur, suivez les étapes suivantes.

1. Téléchargez au moins les [UDF tierces] obligatoires (#preconditions).
2. Déplacez les UDF dans votre dossier de projet ou dans un répertoire où AutoIt peut les trouver.
    - Tous les fichiers *wd_\*.au3* et les fichiers UDF tiers *\*.au3* doivent être placés dans le même répertoire.
    - Sinon, vous devez ajuster les instructions `#include` dans les fichiers.
3. Déplacez le WebDriver de votre choix vers le répertoire contenant les fichiers *wd_\*.au3*.

#### *Utilisation*

Exécutez `wd_demo.au3`, choisissez votre "Navigateur" dans la liste déroulante et appuyez sur "Exécuter la démo !" qui effectuera la démo "DemoNavigation" pour valider votre installation.

<détails>
<summary><i>Exemple de résultat</i></summary>

Si vous utilisez Firefox, le résultat devrait ressembler à ceci :

``` journal
1577745813519 geckodriver DEBUG Écoute sur 127.0.0.1:4444
1577745813744 webdriver :: server DEBUG -> POST /session {"capabilities": {"alwaysMatch": {"browserName": "firefox", "acceptInsecureCerts":true}}}
1577745813746 geckodriver::caabilities DEBUG Essayer de lire la version de firefox à partir des fichiers ini
1577745813747 geckodriver::caabilities DEBUG Trouvé la version 71.0
1577745813757 mozrunner::runner INFO Commande en cours d'exécution : "C:\\Program Files\\Mozilla Firefox\\firefox.exe" "-marionette" "-foreground" "-no-remote" "-profile" "C:\\ . ..
1577745813783 geckodriver :: marionette DEBUG Attente de 60 secondes pour se connecter au navigateur sur 127.0.0.1:55184
1577745817392 geckodriver::marionette DEBUG Connexion à Marionette établie sur 127.0.0.1:55184.
1577745817464 webdriver :: server DEBUG <- 200 OK {"value":{"sessionId":"925641bf-6c5d-4fe2-a985-02de9b1c7c74","capabilities":"acceptInsecureCerts":true,"browserName":"firefox", ...
```

</détails>

D'autres informations utiles suivront bientôt.

## Configuration

Des informations utiles sur les configurations possibles suivront bientôt.<br>

## Contribuant

Regardez [CONTRIBUTING], merci !

## Licence

Distribué sous la licence MIT. Voir [LICENCE] pour plus d'informations.

## Remerciements

- Opportunité par [GitHub](https://github.com)
- Insignes par [Shields] (https://shields.io)
- Remerciements aux auteurs des FDU tiers
  - *Json UDF* par @Ward et @Jos
  - *WinHTTP UDF* par @trancexx/[@dragana-r](https://github.com/dragana-r)
  - * UDF HtmlTable2Array * par @Chimp
  - *WinHttp_WebSocket UDF* par @Danp2
- Merci aux mainteneurs
  - Merci à [@Danp2](https://github.com/Danp2) pour l'idée, la création et la maintenance du projet
  - Merci à [@mLipok](https://github.com/mLipok) pour son *wd_capabilities.au3*
  - Merci à [@Sven-Seyfert](https://github.com/Sven-Seyfert) pour le logo du projet
  - **Un grand merci** à tous les [contributeurs] qui travaillent dur

##

[Jusqu'au sommet](#)

[Chrome48] : https://raw.githubusercontent.com/alrra/browser-logos/main/src/chrome/chrome_48x48.png
[Chrome16] : https://raw.githubusercontent.com/alrra/browser-logos/main/src/chrome/chrome_16x16.png
[Edge48] : https://raw.githubusercontent.com/alrra/browser-logos/main/src/edge/edge_48x48.png
[Edge16] : https://raw.githubusercontent.com/alrra/browser-logos/main/src/edge/edge_16x16.png
[Firefox48] : https://raw.githubusercontent.com/alrra/browser-logos/main/src/firefox/firefox_48x48.png
[Firefox16] : https://raw.githubusercontent.com/alrra/browser-logos/main/src/firefox/firefox_16x16.png
[Opera48] : https://raw.githubusercontent.com/alrra/browser-logos/main/src/opera/opera_48x48.png
[Opera16] : https://raw.githubusercontent.com/alrra/browser-logos/main/src/opera/opera_16x16.png
[ChromeDL] : https://sites.google.com/chromium.org/driver/downloads
[État de Chrome] : https://chromium.googlesource.com/chromium/src/+/master/docs/chromedriver_status.md
[EdgeStatus] : https://docs.microsoft.com/en-us/microsoft-edge/webdriver-chromium/
[EdgeDL] : https://developer.microsoft.com/en-us/microsoft-edge/tools/webdriver/
[FirefoxStatus] : https://developer.mozilla.org/en-US/docs/Mozilla/QA/Marionette/WebDriver/status
[FirefoxDL] : https://github.com/mozilla/geckodriver/releases/latest
[OperaDL] : https://github.com/operasoftware/operachromiumdriver/releases/latest
[Licence] : https://github.com/Danp2/au3WebDriver/blob/master/LICENSE
[Contributeurs] : https://github.com/Danp2/au3WebDriver/graphs/contributors
[W3C WebDriver] : https://www.w3.org/TR/webdriver/
[Wiki WebDriver] : https://www.autoitscript.com/wiki/WebDriver
[Opera Lisez-moi] : https://github.com/operasoftware/operachromiumdriver/blob/master/README.md
[Json UDF] : https://www.autoitscript.com/forum/topic/148114-a-non-strict-json-udf-jsmn
[FDU WinHTTP] : https://github.com/dragana-r/autoit-winhttp/releases/latest
[FDU HtmlTable2Array] : https://www.autoitscript.com/forum/topic/167679-read-data-from-html-tables-from-raw-html-source/
[FDU WinHttp_WebSocket] : https://github.com/Danp2/autoit-websocket
[CONTRIBUER] : https://github.com/Danp2/au3WebDriver/blob/master/docs/CONTRIBUTER.md